Subject: Upgrade Wizard stops at ALTER TABLE index_fulltext ENGINE=InnoDB; 
Description

Using MySQL 5.5, the Upgrade Wizard stops at ALTER TABLE index_fulltext ENGINE=InnoDB; giving the error message:
SQL-ERROR: The used table type doesn't support FULLTEXT indexes;

The same does Database Analyser.

FULLTEXT index with InnoBD is only possible from MySQL Version 5.6.

Is this a bug or is Typo3 6.2 only working with MySQL Version 5.6?

See also: 
http://www.typo3forum.net/forum/typo3-installation-updates/74805-typo3-6-2-3-upgrade-wizard-scheitert-db-tabelle-index_fulltext.html

History
#1 - 2014-06-18 19:07 - Frans Saris

Please try to un-install indexed_search and try then again the upgrade wizard.

Because strange thing is that these table definitions haven't changed in years...

Did you have indexed_search installed before upgrading?

#2 - 2014-06-18 19:20 - Markus Klein

Looks like index_search_mysql comes into the game, as the FULLTEXT index comes from this extension, but it has MyISAM engine defined.

#3 - 2014-06-18 20:15 - Frans Saris

If un-installing doesn't help maybe you can try to run the CREATE TABLE statement manualy

#
# Table structure for table 'index_fulltext'
#
CREATE TABLE index_fulltext (
  phash int(11) DEFAULT '0' NOT NULL,
  fulltextdata mediumtext,
  metaphonedata mediumtext NOT NULL,
  PRIMARY KEY (phash)
) ENGINE=InnoDB;

#4 - 2014-06-18 20:19 - Markus Klein

Frans, I guess the _mysql version of the ext is in the DB, hence the index is already present and the migration to InnoDB (the normal ext version) fails.

#5 - 2014-07-22 13:32 - Paul Kamma

So are there any plans to fix this Bug? I ran into it yesterday after trying to Upgrade from 6.1.7 to the latest Version.

#6 - 2014-07-22 20:58 - Markus Klein

Hi Paula, I honestly have no idea currently, how we could fix that properly nor do I have time to investigate this closer. Sorry from my side.

#7 - 2014-07-23 08:56 - Paul Kamma

Too bad, are there maybe some workarounds like removing the extension?
Regards .. Paul

#8 - 2014-07-23 11:13 - Markus Klein

Workaround would be to remove the indexed_search_mysql extension, update the DB with the analyzer and then run the wizard

#9 - 2014-08-18 18:02 - Jürgen König

Uninstalling indexed_search and indexed_search_mysql worked for me. Thank you!!

#10 - 2014-09-17 14:49 - Jochen Schultz

For me it looks like some developer tries to change the database storage engine from myisam to innodb which doesn't really make sence to me.

The table name is "index_fulltext" and only MyIsam has a fulltext index.

If there might be some sort of logic behind that other than using innodb everywhere because yolo,

you may change to innodb by truncating the table index_fulltext in order to remove the index,

TRUNCATE TABLE index_fulltext;

then remove the index by

ALTER TABLE index_fulltext DROP KEY fulltextdata; 
and change storage engine with:

ALTER TABLE index_fulltext engine=innodb;

Altering the upgrade wizzard might be the better way though.

#11 - 2014-09-17 15:14 - Markus Klein

Hi Jochen,

it is almost impossible to fix the upgrade wizard here due to dependencies and so on.
index_search_mysql requires index_search. When evaluating the DB state and necessary changes it is by far not trivial to determine which action
needs to be taken in which order.
Generally the indexed_search hassle is special with the changing storage engine.
You also have to consider DBs where InnoDB is not available, this will cause other issues then in terms of correct upgrade.

If you find the time to get that perfect, please do so, I'll happily review the patch.
Thanks.

#12 - 2014-09-17 16:35 - Jochen Schultz

May i suggest to use MyIsam as standard then in typo3\sysext\indexed_search\ext_tables.sql:

CREATE TABLE index_fulltext (
  phash int(11) DEFAULT '0' NOT NULL,
  fulltextdata mediumtext,
  metaphonedata mediumtext,
  PRIMARY KEY (phash)
  FULLTEXT fulltextdata (fulltextdata)
  FULLTEXT metaphonedata (metaphonedata)
) ENGINE=MyISAM;

instead of

CREATE TABLE index_fulltext (
  phash int(11) DEFAULT '0' NOT NULL,
  fulltextdata mediumtext,
  metaphonedata mediumtext NOT NULL,
  PRIMARY KEY (phash)
) ENGINE=InnoDB;

I am actually new inside the typo3 community and i don't know about the common ways to fix it yet.
So could you please be so kind and actually do the changes inside the extension in what ever kind of concurrent versioning system the core is inside?

2015-08-04 3/4



I am not lazy, but just got many new tickets i have to work on with higher priorities...
